type expr =
  | IntLit of int
  | Plus of expr * expr
  | Mult of expr * expr

(* "(3 + 2) * 3" vs. "3 + (2 * 3)" *)
(*  ^^^ Mult(Plus(IntLit 3, IntLit 2), IntLit 3) *)
(*                   ^^^ Plus(IntLit 3, Mult(IntLit 2, IntLit 3)) *)
